package de.V10lator.BukkitHTTPD;

import java.util.UUID;

import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerListener;

/**
 * 
 * @author V10lator
 *
 */
public class BukkitHTTPDPlayerListener extends PlayerListener
{
  private final BukkitHTTPD plugin;
  
  public BukkitHTTPDPlayerListener(BukkitHTTPD plugin)
  {
	this.plugin = plugin;
  }
  
  public void onPlayerChat(PlayerChatEvent event)
  {
	if(event.isCancelled())
	  return;
	
	UUID uuid = UUID.randomUUID();
	plugin.chatBuffer.put(uuid, event.getPlayer().getDisplayName()+ ": " + event.getMessage());
	plugin.chatMappings.put(uuid, System.currentTimeMillis() / 1000L);
  }
}
