package de.V10lator.BukkitHTTPD;

import java.util.Map.Entry;
import java.util.UUID;

import org.bukkit.OfflinePlayer;
import org.bukkit.Server;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

/**
 * 
 * @author V10lator
 *
 */
public class RAMFiller implements Runnable
{
  private final BukkitHTTPD plugin;
  private int[] ta = new int[] {0, 0};
  
  public RAMFiller(BukkitHTTPD plugin)
  {
	this.plugin = plugin;
  }
  
  public void run()
  {
	Server server = plugin.getServer();
	if(!plugin.ram.lock.compareAndSet(false, true))
	{
	  if(ta[1] < 10)
	  {
		ta[1]++;
		server.getScheduler().scheduleSyncDelayedTask(plugin, this, 1L);
	  }
	  return;
	}
	ta[1] = 0;
	if(ta[0] == 0)
	{
	  plugin.ram.players.clear();
	  for(Player p: server.getOnlinePlayers())
	    plugin.ram.players.add(p.getName());
	
	  plugin.ram.maxPlayers = server.getMaxPlayers();
	  
	  plugin.ram.worlds.clear();
	  plugin.ram.worldTimes.clear();
	  for(World world: server.getWorlds())
	  {
		String wn = world.getName();
		plugin.ram.worlds.add(wn);
		plugin.ram.worldTimes.put(wn, world.getTime());
	  }
	}
	else if(ta[0] == 1)
	{
	  plugin.ram.plugins.clear();
	  for(Plugin p: server.getPluginManager().getPlugins())
	    plugin.ram.plugins.add(p.getDescription().getName());
	  
	  plugin.ram.bannedPlayers.clear();
	  for(OfflinePlayer bp: server.getBannedPlayers())
	    plugin.ram.bannedPlayers.add(bp.getName());
	}
	else if(ta[0] == 2)
	{
	  for(Entry<UUID, String> e: plugin.chatBuffer.entrySet())
	  {
	    UUID uuid = e.getKey();
	    plugin.ram.chatPtH.put(uuid, e.getValue());
	    plugin.ram.chatMappings.put(uuid, plugin.chatMappings.get(uuid));
	  }
	  plugin.chatBuffer.clear();
	  plugin.chatMappings.clear();
	}
	else if(ta[0] == 3)
	{
	  plugin.ram.gameMode = server.getDefaultGameMode().name();
	  
	  plugin.ram.ipBans.clear();
	  for(String ib: server.getIPBans())
		plugin.ram.ipBans.add(ib);
	}
	else if(ta[0] == 4)
	{
	  for(Entry<String, Function> e: BukkitHTTPD_API.functions.entrySet())
	  {
	    Function f = e.getValue();
	    if(f == null)
		  continue;
	    f.onBukkitExecute();
	    plugin.ram.functions.put(e.getKey(), f);
	  }
	}
	else if(ta[0] == 5)
	{
	  plugin.ram.serverName = plugin.config.getString("ServerName", "My Awesome Server");
	  
	  int port = server.getPort();
	
	  if(port == 25565 || plugin.config.getBoolean("HidePort", false))
		plugin.ram.serverHost = server.getIp();
	  else
	    plugin.ram.serverHost = server.getIp()+":"+port;
	}
	else if(ta[0] == 6)
	{
	  plugin.ram.color = plugin.config.getString("Color", "000000");
	  
	  for(String tc: plugin.ram.chatHtP)
	    server.broadcastMessage(tc);
	  plugin.ram.chatHtP.clear();
	}
	
	ta[0]++;
	if(ta[0] > 6)
	  ta[0] = 0;
	
	if(plugin.ram.reboot)
	  server.reload();
	else if(plugin.ram.shutdown)
	  server.shutdown();
	else
	  plugin.ram.lock.set(false);
  }
}
